<?php
/**
 * Celebrio Core
 *
 * @copyright  Copyright (c) 2011 Celebrio Software
 * @package    Celebrio
 * @subpackage Core
 */
namespace Celebrio\AccessControl;

use Nette\Object;

use KernelModule\AclModule\AclManagement;

use Celebrio\Core\IModuleInit;
use Celebrio\Core\DummyInit;

use Celebrio\AccessControl\AclConstants;
use \KernelModule\AclModule\AclRole;

class AclCreater extends DummyInit implements IModuleInit {

    private $aclManagement;

    public function __construct() {
        $this->aclManagement = new AclManagement();
    }

    /**
     * Installs the module (loads it to the system for the first time).
     * This method should contain all the routines which are executed
     * only once (creating DB tables et cetera).
     */
    public function install(array $configuration) {

        parent::install($configuration);

        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Overview", "default", true, AclConstants::ROOT_USER);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Overview", "info", true, null);

        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Modules:ModulesManagement", "default", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Modules:ModulesManagement", "install", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Modules:ModulesManagement", "uninstall", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Modules:ModulesManagement", "select", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Modules:ModulesManagement", "upgrade", true, null);

        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Modules:DatabaseManagement", "default", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Modules:FileSystemManagement", "default", true, null);
        //$this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Modules:UsersManagement", "default", true, null);
        //$this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Modules:WebtopManagement", "default", true, null);

        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Modules:Console", "default", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Modules:Terminal", "default", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Modules:GoogleApi", "default", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Modules:GoogleApi", "access", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Modules:GoogleApi", "authorized", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Modules:Picasa", "default", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Modules:Picasa", "access", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Modules:Picasa", "authorized", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Modules:Picasa", "test", true, null);

        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Logs:Overview", "default", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Logs:Error", "default", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Logs:Error", "delete", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Logs:Error", "fsProblem", true, null);

        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Logs:Php:Process", "default", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Logs:Php:Process", "refreshAzureLogs", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Logs:Php:Display", "default", true, null);
        // no link to :Kernel:Logs:Php:Display:check
        // $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Logs:Php:Display", "check", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Logs:Php:Detail", "default", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Logs:Php:Detail", "debuggerRed", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Logs:Logger:Display", "general", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Logs:Logger:Display", "debug", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Logs:Logger:Display", "errors", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:UsersOverview", "default", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Logs:Acl:Display", "default", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Logs:Performance:Display", "default", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Logs:Performance:Display", "loglevel", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Logs:Performance:Display", "delete", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Logs:Performance:Display", "deletestatistics", true, null);

        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Users:Overview", "default", true, null);

        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Users:Users", "default", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Users:Users", "add", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Users:Users", "delete", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Users:Users", "edit", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Users:Users", "access", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Users:Users", "hooks", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Users:Users", "deleteGuests", true, null);

        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Users:Roles", "default", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Users:Roles", "add", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Users:Roles", "delete", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Users:Roles", "edit", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Users:Roles", "users", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Users:Roles", "access", true, null);

        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Acl:Overview", "default", true, null);

        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Acl:Resources", "default", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Acl:Resources", "add", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Acl:Resources", "delete", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Acl:Resources", "edit", true, null);

        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Acl:Privileges", "default", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Acl:Privileges", "add", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Acl:Privileges", "delete", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Acl:Privileges", "edit", true, null);

        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Acl:Permissions", "default", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Acl:Permissions", "add", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Acl:Permissions", "delete", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Kernel:Acl:Permissions", "edit", true, null);
        $this->aclManagement->addOneRule(AclConstants::ADMIN_ROLE, "Webtop:Default", "default", true, null);

        // add guest role

        $roles = array(
//            AclConstants::NETTE_GUEST, // not necessary, hopefully
            AclConstants::GUEST_ROLE,
            AclConstants::REGISTERED_ROLE
        );
        foreach ($roles as $role_name) {
            $role = new AclRole();
            $role->setName($role_name);
            $this->aclManagement->addRole($role);
        }
    }

}