CREATE TABLE `logins`
(
  `user_id` Int(10) UNSIGNED NOT NULL,
  `time` Timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `ip` Char(39) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `host` Varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `agent` Varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL
) ENGINE = InnoDB
  DEFAULT CHARACTER SET utf8
  COLLATE utf8_general_ci
  ROW_FORMAT = Compact
;

ALTER TABLE `logins` ADD PRIMARY KEY (`user_id`,`time`);
CREATE INDEX `logins users` USING BTREE ON `logins` (`user_id`);

-- Table passwords

CREATE TABLE `passwords`
(
  `user_id` Int(10) UNSIGNED NOT NULL,
  `password` Char(128) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `created` Timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP
) ENGINE = InnoDB
  DEFAULT CHARACTER SET utf8
  COLLATE utf8_general_ci
  ROW_FORMAT = Compact
;

ALTER TABLE `passwords` ADD PRIMARY KEY (`user_id`,`created`);

CREATE INDEX `passwords users` USING BTREE ON `passwords` (`user_id`);

-- Table security_questions

CREATE TABLE security_questions
(
  user_id Int(10) UNSIGNED NOT NULL,
  question Varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  answer Varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL
) ENGINE = InnoDB
  DEFAULT CHARACTER SET utf8
  COLLATE utf8_general_ci
  ROW_FORMAT = Compact
;

ALTER TABLE security_questions ADD PRIMARY KEY (user_id);

CREATE INDEX `security question user` USING BTREE ON security_questions (user_id);

-- Table users

CREATE TABLE users
(
  id Int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  id_person Int(10) UNSIGNED,
  user_name Varchar(45) CHARACTER SET utf8 COLLATE utf8_general_ci UNIQUE NOT NULL,
  first_name Varchar(45) CHARACTER SET utf8 COLLATE utf8_general_ci,
  last_name Varchar(45) CHARACTER SET utf8 COLLATE utf8_general_ci,
  created Timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `status` Varchar(10) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `expiration` Timestamp,
  language Char(5) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  time_zone Varchar(45) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
 PRIMARY KEY (id)
) ENGINE = InnoDB
  DEFAULT CHARACTER SET utf8
  COLLATE utf8_general_ci
  ROW_FORMAT = Compact
;


CREATE TABLE guest_log
(
 guest_count Int(10) NOT NULL PRIMARY KEY
) ENGINE = InnoDB
  DEFAULT CHARACTER SET utf8
  COLLATE utf8_general_ci
  ROW_FORMAT = Compact
;


-- Create relationships section ------------------------------------------------- 

ALTER TABLE `logins` ADD CONSTRAINT `logins users` FOREIGN KEY (user_id) REFERENCES users (id) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `passwords` ADD CONSTRAINT `passwords users` FOREIGN KEY (user_id) REFERENCES users (id) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `security_questions` ADD CONSTRAINT `security question user` FOREIGN KEY (user_id) REFERENCES users (id) ON DELETE CASCADE ON UPDATE CASCADE;
