CREATE TABLE "logins"(
 "user_id" Integer NOT NULL,
 "time" Timestamp(6) DEFAULT CURRENT_TIMESTAMP NOT NULL,
 "ip" Character(39) NOT NULL,
 "host" Character varying(255) NOT NULL,
 "agent" Character varying(255) NOT NULL
) WITH (OIDS=FALSE);

CREATE INDEX "logins users" ON "logins" ("user_id");
ALTER TABLE "logins" ADD CONSTRAINT "PK_logins" PRIMARY KEY ("user_id","time");


-- Table passwords

CREATE TABLE "passwords"(
 "user_id" Integer NOT NULL,
 "password" Character(128) NOT NULL,
 "created" Timestamp(6) DEFAULT CURRENT_TIMESTAMP NOT NULL
) WITH (OIDS=FALSE);

CREATE INDEX "passwords users" ON "passwords" ("user_id");
ALTER TABLE "passwords" ADD CONSTRAINT "PK_passwords" PRIMARY KEY ("user_id","created");


-- Table security_questions

CREATE TABLE "security_questions"(
 "user_id" Integer NOT NULL,
 "question" Character varying(255) NOT NULL,
 "answer" Character varying(255) NOT NULL
) WITH (OIDS=FALSE);

CREATE INDEX "security question user" ON "security_questions" ("user_id");
ALTER TABLE "security_questions" ADD CONSTRAINT "PK_security_questions" PRIMARY KEY ("user_id");


-- Table users

CREATE TABLE "users"(
 "id" Serial,
 "id_person" Integer,
 "user_name" Character varying(45) UNIQUE NOT NULL,
 "first_name" Character varying(45),
 "last_name" Character varying(45),
 "created" Timestamp(6) DEFAULT CURRENT_TIMESTAMP NOT NULL,
 "status" Character varying(10) NOT NULL,
 "expiration" Timestamp(6),
 "language" Character(5) NOT NULL,
 "time_zone" Character varying(45) NOT NULL
) WITH (OIDS=FALSE);

ALTER TABLE "users" ADD CONSTRAINT "PK_users" PRIMARY KEY ("id");


CREATE TABLE "guest_log" (
 "guest_count" Int NOT NULL PRIMARY KEY
) WITH (OIDS=FALSE);


-- Create relationships section ------------------------------------------------- 

ALTER TABLE "logins" ADD CONSTRAINT "logins users" FOREIGN KEY ("user_id") REFERENCES "users" ("id") ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE "passwords" ADD CONSTRAINT "passwords users" FOREIGN KEY ("user_id") REFERENCES "users" ("id") ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE "security_questions" ADD CONSTRAINT "security question user" FOREIGN KEY ("user_id") REFERENCES "users" ("id") ON DELETE CASCADE ON UPDATE CASCADE;

