<?php
/**
 * Celebrio FileSystem module
 *
 * @copyright  Copyright (c) 2011 Celebrio Software
 * @package    Celebrio
 * @subpackage FileSystem
 */
namespace Celebrio\FileSystem;

use Nette\Object;

use Celebrio\FileSystem\VirtualFile;

/**
 * FileInfo contains the attributes we might want to know
 * about the file, such as who is owner, whether the file
 * is hidden and so on.
 *
 * @author pavel
 */
class FileInfo extends Object {


    /** @var String username of the owner */
    private $ownerName = null;
    
    /** @var bool */
    private $hidden = false;
    
    /** @var bool */
    private $protected = false;
    
    /** @var bool */
    private $encrypted = false;
    
    /** @var String the user who locked the file */
    private $lockedByName = null;
    
    public function getOwnerName() {
        return $this->ownerName;
    }

    public function setOwnerName($ownerName) {
        $this->ownerName = $ownerName;
    }

    public function getHidden() {
        return $this->hidden;
    }

    public function setHidden($hidden) {
        $this->hidden = $hidden;
    }

    public function getProtected() {
        return $this->protected;
    }

    public function setProtected($protected) {
        $this->protected = $protected;
    }

    public function getEncrypted() {
        return $this->encrypted;
    }

    public function setEncrypted($encrypted) {
        $this->encrypted = $encrypted;
    }

    public function getLockedByName() {
        return $this->lockedByName;
    }

    public function setLockedByName($lockedByName) {
        $this->lockedByName = $lockedByName;
    }

}