<?php
/**
 * Celebrio FileSystem module
 *
 * @copyright  Copyright (c) 2011 Celebrio Software
 * @package    Celebrio
 * @subpackage FileSystem
 */
namespace Celebrio\FileSystem;

use Celebrio\FileSystem\DataFile;

/**
 * IFile interface for the GenericFile and all inherited classes.
 * Every virtualized File structure in the FileSystem module should
 * implement this interface (i.e GenericFile, DataFile and VirtualFile).
 *
 * Basicaly, all mandatory methods are implemented in the GenericFile
 * and every other virtual file structure should inherit it.
 * 
 * @author pavel
 */
interface IFile {

    function getUrl();
    function getName();
 
    function isDirectory();
}