
-- IMPORTANT: TODO: in relationship section-> create triggers that would properly set values in tables during dele or update
-- change only the lines with comments
-- Table files

CREATE TABLE [files]
(
 [id_file] Int IDENTITY(1,1) NOT NULL,
 [id_user] Int NULL,
 [id_mimetype] Int NOT NULL,
 [url] nvarchar(255) NULL,
 [name_file] nvarchar(255) NOT NULL,
 [hidden] Bit DEFAULT 0 NOT NULL,
 [protected] Bit DEFAULT 0 NOT NULL,
 [encrypted] Bit DEFAULT 0 NOT NULL,
 [locked] Int NULL,
 [deleted] Bit DEFAULT 0 NOT NULL,
 [id_parent] Int NULL,
 [hash] nchar(128) NULL,
 [id_files_storage] Int NOT NULL
);

-- Add keys for table files

ALTER TABLE [files] ADD CONSTRAINT [files_pk] PRIMARY KEY ([id_file]);

-- Table fpermissions

CREATE TABLE [fpermissions]
(
 [id_file] Int NOT NULL,
 [id_role] Int NOT NULL,
 [id_fprivilege] Int NOT NULL,
 [allowed] Bit DEFAULT 1 NOT NULL
);

-- Add keys for table fpermissions

ALTER TABLE [fpermissions] ADD CONSTRAINT [Key4] PRIMARY KEY ([id_fprivilege],[id_role],[id_file]);

-- Table fprivileges

CREATE TABLE [fprivileges]
(
 [id_fprivilege] Int IDENTITY(1,1) NOT NULL,
 [name] nvarchar(255) NOT NULL
);

-- Add keys for table fprivileges

ALTER TABLE [fprivileges] ADD CONSTRAINT [fprivileges_pk] PRIMARY KEY ([id_fprivilege]);

ALTER TABLE [fprivileges] ADD CONSTRAINT [name] UNIQUE ([name]);

-- Table mimetypes

CREATE TABLE [mimetypes]
(
 [id_mimetype] Int IDENTITY(1,1) NOT NULL,
 [name_mimetype] nvarchar(40) NULL
);

-- Add keys for table mimetypes

ALTER TABLE [mimetypes] ADD CONSTRAINT [mimetypes_pk] PRIMARY KEY ([id_mimetype]);

-- Table file_changes

CREATE TABLE [file_changes]
(
 [id_file_change] Int IDENTITY(1,1) NOT NULL,
 [id_file] Int NULL,
 [time] Datetime2 NULL,
 [action] Smallint NULL,
 [id_user] Int NULL,
 [name_file] nvarchar(255) NOT NULL,
 [user_name] nvarchar(45) NOT NULL
);

-- Add keys for table file_changes

ALTER TABLE [file_changes] ADD CONSTRAINT [files_changes_pk] PRIMARY KEY ([id_file_change]);

-- Table files_storages

CREATE TABLE [files_storages]
(
 [id_files_storage] Int IDENTITY(1,1) NOT NULL,
 [name_files_storage] nvarchar(255) NULL
);

-- Add keys for table files_storages

ALTER TABLE [files_storages] ADD CONSTRAINT [id_files_storage] PRIMARY KEY ([id_files_storage]);

-- Create relationships section -------------------------------------------------

ALTER TABLE [files] ADD CONSTRAINT [users_files] FOREIGN KEY ([id_user]) REFERENCES [users] ([id]) ON UPDATE CASCADE ON DELETE SET NULL;

ALTER TABLE [fpermissions] ADD CONSTRAINT [files_fpermissions] FOREIGN KEY ([id_file]) REFERENCES [files] ([id_file]) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE [fpermissions] ADD CONSTRAINT [roles_fpermissions] FOREIGN KEY ([id_role]) REFERENCES [roles] ([id]) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE [fpermissions] ADD CONSTRAINT [fprivileges_fpermissions] FOREIGN KEY ([id_fprivilege]) REFERENCES [fprivileges] ([id_fprivilege]) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE [files] ADD CONSTRAINT [mimetypes_files] FOREIGN KEY ([id_mimetype]) REFERENCES [mimetypes] ([id_mimetype]) ON UPDATE CASCADE ON DELETE NO ACTION;

ALTER TABLE [file_changes] ADD CONSTRAINT [files_file_changes] FOREIGN KEY ([id_file]) REFERENCES [files] ([id_file]) ON UPDATE CASCADE ON DELETE SET NULL;

ALTER TABLE [file_changes] ADD CONSTRAINT [users_file_changes] FOREIGN KEY ([id_user]) REFERENCES [users] ([id]) ON UPDATE NO ACTION ON DELETE NO ACTION-- ON UPDATE CASCADE ON DELETE SET NULL; <- it must work this way

ALTER TABLE [files] ADD CONSTRAINT [users_files_lock] FOREIGN KEY ([locked]) REFERENCES [users] ([id]) ON UPDATE NO ACTION ON DELETE NO ACTION; --ON UPDATE CASCADE ON DELETE SET NULL; <- it must work this way

ALTER TABLE [files] ADD CONSTRAINT [file_parent] FOREIGN KEY ([id_parent]) REFERENCES [files] ([id_file]) ON UPDATE NO ACTION ON DELETE NO ACTION; --ON UPDATE CASCADE ON DELETE NO ACTION; <- it must work this way

ALTER TABLE [files] ADD CONSTRAINT [file_storages_files] FOREIGN KEY ([id_files_storage]) REFERENCES [files_storages] ([id_files_storage]) ON UPDATE CASCADE ON DELETE NO ACTION;

----table [users] must be in database
--CREATE TRIGGER [users_file_changes_update_trigger]
--ON [users]
--AFTER UPDATE
--AS
--BEGIN
--END;
